#
# config.mk
#
# This file is part of mkimage
# Copyright (C) 2007-2009  Alexey Gladkov <gladkov.alexey@gmail.com>
#
# This file is covered by the GNU General Public License,
# which should be included with mkimage as the file COPYING.
#

INCLUDED_CONFIG_MK = 1

MKI_VERSION	= 0.2.3
GLOBAL_PREFIX	?= /usr/share/mkimage
CONFIGDIR 	?= $(GLOBAL_PREFIX)
TOOLSDIR 	?= $(GLOBAL_PREFIX)/tools

GLOBAL_WORKROOT	?=

include		$(CONFIGDIR)/tools.mk

WORKDIRNAME	= .work
OUTDIRNAME	= .out
CACHEDIRNAME	= .cache

MYMAKEFILE 	= $(shell $(GET_MAKEFILE) $(CURDIR))
WORKDIR 	= $(CURDIR)/$(WORKDIRNAME)
CACHEDIR	= $(WORKDIR)/$(CACHEDIRNAME)
PKGBOX		= $(WORKDIR)/pkgbox

PREVDIR		= $(dir $(PWD))
TOPDIR 		= $(shell $(GET_TOPDIR) $(PWD))
OUTDIR		?= $(WORKDIR)/$(OUTDIRNAME)

PROFILE		?=
SUBDIRS		?=
CLEANUP_OUTDIR	?= 1

GLOBAL_TARGET	?=
TARGET		= $(GLOBAL_TARGET)
ifeq ($(shell uname -m),x86_64)
    TARGET ?= $(shell uname -m)
else
    TARGET ?= i586
endif

GLOBAL_QUIET ?=
QUIET = $(GLOBAL_QUIET)

GLOBAL_VERBOSE	?=
ifdef GLOBAL_QUIET
    GLOBAL_VERBOSE =
endif
VERBOSE = $(GLOBAL_VERBOSE)

NO_CACHE =
NO_REMOTES =

MKI_SCRIPTDIR = $(CURDIR)/scripts.d
MKI_IMAGE_SCRIPTDIR = $(CURDIR)/image-scripts.d

CHROOT_PACKAGES =
CHROOT_PACKAGES_REGEXP =

IMAGE_PACKAGES =
IMAGE_PACKAGES_REGEXP =

IMAGE_INIT_LIST ?=

MKI_DESTDIR =
COPY_TREE =

MKI_PACK_RESULTS ?=
MKI_PACKTYPE =
MKI_OUTNAME ?=

MKI_IMAGESUBDIR =
MKI_COMPRESSTYPE =

MKI_SPLIT =
MKI_SPLITTYPE =

MKI_TAR_COMPRESS =
MKI_CPIO_COMPRESS =

MKI_SORTFILE ?=

GLOBAL_BOOT_LANG ?=
BOOT_LANG = $(GLOBAL_BOOT_LANG)
BOOT_TYPE =

BOOT_APPI =
BOOT_COPY =
BOOT_ABST =
BOOT_BIBL =
BOOT_PREP =
BOOT_PUBL =
BOOT_SYSI =
BOOT_VOLI =
BOOT_VOLS =

ISODATA_APPI =
ISODATA_COPY =
ISODATA_ABST =
ISODATA_BIBL =
ISODATA_PREP =
ISODATA_PUBL =
ISODATA_SYSI =
ISODATA_VOLI =
ISODATA_VOLS =

PACK_UBIFS_OPTS =
PACK_UBI_OPTS =

PACK_UBI_MIN_IO_SIZE =

PACK_UBI_VOL_TYPE =
PACK_UBI_VOL_NAME =

# optional
PACK_UBI_VOL_ID =
PACK_UBI_VOL_SIZE =
PACK_UBI_VOL_FLAGS =
PACK_UBI_VOL_ALIGN =


include	$(CONFIGDIR)/config-requires.mk
include	$(CONFIGDIR)/config-hasher.mk
include	$(CONFIGDIR)/config-squash.mk
include	$(CONFIGDIR)/config-propagator.mk

all: __profile_internal_rule
